import java.util.*;
public class Misc {
	public static void main(String[] args) {
		int[] arr = {11, 5, 10, 13, 23};

		int min = findMin(arr);
		System.out.println("Min: " + min);

		int product = findProduct(arr);
		System.out.println("Product: " + product);

		int secondSmallestValue = find2ndMin(arr);
		System.out.println("Second smallest value: " + secondSmallestValue);

		int[] prefixSum = findPrefixSum(arr);
		System.out.println(Arrays.toString(prefixSum));

		String[] names = {"Wissam", "Chadi", "Ali", "Charbel"};
		String shortestName = findShortest(names);
		System.out.println("Shortest name: " + shortestName);		
	}

	private static int findMin(int[] arr) {
		// Approach#1
		/*Arrays.sort(arr);
		return arr[0];*/
		// Approach#2
		int min = Integer.MAX_VALUE;
		for(int val : arr) {
			if(val < min) min = val;
		}
		return min;
	}

	private static int findProduct(int[] arr) {
		int result = 1;

		for(int val : arr) {
			result*= val;
		}
		return result;
	}

	private static String findShortest(String[] names) {
		int minLength = Integer.MAX_VALUE;
		String shortestWord = "";
		int length;
		for(String name : names) {
			length = name.length();
			if(length < minLength) {
				minLength = length;
				shortestWord = name;
			}
		}

		return shortestWord;
	}

	private static int find2ndMin(int[] arr) {
		/*Arrays.sort(arr);
		return arr[1];*/
		int min = Integer.MAX_VALUE, secondMin = Integer.MAX_VALUE;

		for(int val : arr) {
			if(val < min) {
				secondMin = min;
				min = val;
			} else if(val < secondMin && val != min) {
				secondMin = val;
			}
		}
		return secondMin;
	}

	private static int[] findPrefixSum(int[] arr) {
		int[] result = new int[arr.length];
		result[0] = arr[0];
		for(int idx=1; idx < arr.length; idx++){
			result[idx] = result[idx-1] + arr[idx];
		}

		return result;

	}


}